import { NextFunction, Request, Response } from 'express';
import { CreateUserDto } from '../dtos/user.dto';
import AuthService from '../services/auth.service';
import { User } from '../interfaces/user.interface';
import { RequestWithUser } from '../interfaces/auth.interface';

class AuthController {
  public authService = new AuthService();

  public signUp = async (req: Request, res: Response, next: NextFunction) => {
    const userData: CreateUserDto = req.body;
    try {
      const signUpUserData: User = await this.authService.signup(userData);
      res.status(201).json({ data: signUpUserData, message: 'signup' });
    } catch (error) {
      next(error);
    }
  };

  public logIn = async (req: Request, res: Response, next: NextFunction) => {
    const userData: CreateUserDto = req.body;
    try {
      console.log("----------------------",userData);
      
      const authData = await this.authService.login(userData);
      if(authData.status == 200){
        res.setHeader('Set-Cookie', [authData.data.cookie]);
        authData.data = authData.data.findUser;
        res.status(200).json(authData);
      }else{
        res.status(authData.status).json(authData);
      }
     
    } catch (error) {
      console.log(error);
      
    }
  };

  public tokenValidator = async (req:any,res:Response,next :NextFunction) => {
    try {
      console.log("----------------------",req.user);
      if(req.user){
        res.status(200).json(req.user);
      }
      // const authData = await this.authService.login();
      // if(authData.status == 200){
      //   res.setHeader('Set-Cookie', [authData.data.cookie]);
      //   authData.data = authData.data.findUser;
      //   res.status(200).json(authData);
      // }else{
      //   res.status(authData.status).json(authData);
      // }
     
    } catch (error) {
      console.log(error);
      
    }
  }

  public logOut = async (req: RequestWithUser, res: Response, next: NextFunction) => {
    const userData: User = req.user;
    try {
      const logOutUserData: User = await this.authService.logout(userData);
      res.setHeader('Set-Cookie', ['Authorization=; Max-age=0']);
      res.status(200).json({ data: logOutUserData, message: 'logout' });
    } catch (error) {
      next(error);
    }
  };
}

export default AuthController;
