import { NextFunction, Request, Response } from 'express';
import sdgService from '../services/init.service';
import { StatusCodes } from 'http-status-codes';
import { IResponse } from '../interfaces/response.interface';

class initController {
  public sdgService = new sdgService();
  public iResponse: IResponse;

  public getSdg = async (req, res, next) => {
    try {
      const sdgData = await this.sdgService.getSdg();
      this.iResponse = { data: sdgData, message: 'find' };
      res.status(StatusCodes.OK).json(this.iResponse);
    } catch (error) {
      next(error);
    }
  };
}
export default initController;
