import { IsEmail, IsString, IsMongoId, IsOptional } from 'class-validator';

export class CreateUserDto {
  @IsEmail()
  public email: string;

  @IsString()
  public first_name: string;

  @IsString()
  public last_name: string;

  @IsString() @IsOptional()
  public address: string;

  @IsString() @IsOptional()
  public state: string;

  @IsString()
  public city: string;

  @IsString() @IsOptional()
  public pincode: string;

  @IsString()
  public phone: string;

  @IsString() @IsOptional()
  public country: String;

  @IsString() @IsOptional()
  public nationality: String;
  
  @IsString() @IsOptional()
  public age: String;

  @IsString() @IsOptional()
  public gender:String;

  @IsString() @IsOptional()
  public profession:String;

  @IsMongoId()
  public role: string;

  @IsString()
  public password: string;
}
