import { NextFunction, Response } from 'express';
import HttpException from '../exceptions/HttpException';
import { RequestWithUser } from '../interfaces/auth.interface';

const aclMiddleware = async (req: RequestWithUser, res: Response, next: NextFunction) => {
  try {
    if (req.user) {
      console.log(req.user.role);
    } else {
      next(new HttpException(404, 'Authentication token missing'));
    }
  } catch (error) {
    next(new HttpException(401, 'Wrong authentication token'));
  }
};

export default aclMiddleware;
