import { model, Schema, Document, SchemaTypes } from 'mongoose';
import { Application } from '../interfaces/application.interface';
import paginate from './plugins/paginate.plugin';
import toJSON from './plugins/toJSON.plugin';

const applicationSchema: Schema = new Schema(
  {
    data: {
      type: Object,
      required: true,
    },
    // resources: [],
    challenge: {
      type: SchemaTypes.ObjectId,
      ref: 'Challenge',
      required: true,
    },
    user: {
      type: SchemaTypes.ObjectId,
      ref: 'User',
      required: true,
    },
    // financial_doc: {
    //   type: String,
    // },
    // project_doc: {
    //   type: String,
    // },
    // status: {
    //   type: String,
    //   enum: ['PENDING', 'DUPLICATE', 'CONFIRMED', 'UNDER PRESCREENING', 'UNDER SCREENING', 'SHORTLISTED', 'WINNER'],
    //   default: 'PENDING',
    //   required: true,
    // },
  },
  {
    timestamps: true,
  },
);

applicationSchema.plugin(toJSON);
applicationSchema.plugin(paginate);

const applicationModel = model<Application & Document>('Application', applicationSchema);

export default applicationModel;
