import { model, Schema, Document } from 'mongoose';
import { sdg } from '../interfaces/sdg.interface';
import paginate from './plugins/paginate.plugin';
import toJSON from './plugins/toJSON.plugin';

const sdgSchema: Schema = new Schema({
  name: {
    type: String,
    required: true,
  },
  order: {
    type:Number,
  },
  color: {
    type: String,
  },
});

sdgSchema.plugin(toJSON);
sdgSchema.plugin(paginate);

const sdgModel = model<sdg & Document>('sdg', sdgSchema);

export default sdgModel;
