import { model, Schema, Document } from 'mongoose';
import { Step } from '../interfaces/step.interface';
import paginate from './plugins/paginate.plugin';
import toJSON from './plugins/toJSON.plugin';

const stepSchema: Schema = new Schema(
  {
    isActive: {
      type:Boolean
    },
    stage_name: {
      type:String
    },
    tag_line:{
      type:String
    },
    end_date:{
      type:Date
    },
    mandFlg: {
      type:Boolean
    },
    parameters: [],
    status: {
      type: String,
      enum: ['ACTIVE', 'INACTIVE'],
      default:"ACTIVE"
    },
  },
  {
    timestamps: true,
  },
);

stepSchema.plugin(toJSON);
stepSchema.plugin(paginate);

const stepModel = model<Step & Document>('Step', stepSchema);

export default stepModel;
