import { model, Schema, Document } from 'mongoose';
import { Uniqueid } from '../interfaces/uniqueid.interface';
import paginate from './plugins/paginate.plugin';
import toJSON from './plugins/toJSON.plugin';

const uniqueidSchema: Schema = new Schema({
  type: {
    type: String,
    required: true,
  },
  currentValue: {
    type:Number,
    default:0
  },
  description: {
    type: String,
  },
  agency_code:{
      type:String
  }
});

uniqueidSchema.plugin(toJSON);
uniqueidSchema.plugin(paginate);

const uniqueidModel = model<Uniqueid & Document>('uniqueid', uniqueidSchema);

export default uniqueidModel;
