import { Router } from 'express';
import initController from '../controllers/init.controller';
import { CreateRoleDto } from '../dtos/role.dto';
import Route from '../interfaces/route.interface';
import validationMiddleware from '../middlewares/validation.middleware';
import authMiddleware from '../middlewares/auth.middleware';
class initRoute implements Route {
  public path = '/init';
  public router = Router();
  public initController = new initController();

  constructor() {
    this.initializeRoutes();
  }

  private initializeRoutes() {
    this.router.get(`${this.path}/sdg`, this.initController.getSdg);
  }
}

export default initRoute;
