import 'dotenv/config';
import App from './app';
import AuthRoute from './routes/auth.route';
import IndexRoute from './routes/index.route';
import UsersRoute from './routes/user.route';
import RolesRoute from './routes/role.route';
import ChallengesRoute from './routes/challenge.route';
import StepsRoute from './routes/step.route';
import ApplicationsRoute from './routes/application.route';
import VideosRoute from './routes/video.route';
import validateEnv from './utils/validateEnv';
import AgencyRoute from './routes/agency.route';
import initRoute from './routes/init.route';

validateEnv();

const app = new App([
  new IndexRoute(),
  new UsersRoute(),
  new AuthRoute(),
  new RolesRoute(),
  new initRoute(),
  new ChallengesRoute(),
  new StepsRoute(),
  new ApplicationsRoute(),
  new VideosRoute(),
  new AgencyRoute(),
 
]);
process.on('unhandledRejection', (reason, p) => {
    console.error(reason, 'Unhandled Rejection at Promise', p);
})
.on('uncaughtException', err => {
    console.error(err, 'Uncaught Exception thrown');
    process.exit(1);
});
app.listen();
