import { CreateChallengeDto } from '../dtos/challenge.dto';
import HttpException from '../exceptions/HttpException';
import { Challenge } from '../interfaces/challenge.interface';
import challengeModel from '../models/challenge.model';
import { isEmpty } from '../utils/util';

class ChallengeService {
  public challenges = challengeModel;

  public async findAllChallenge(): Promise<Challenge[]> {
    const challenges: Challenge[] = await this.challenges.find().populate(["agency_id",'sdg']);
    return challenges;
  }

  public async findChallengeById(challengeId: string): Promise<Challenge> {
    const findChallenge: Challenge = await this.challenges.findById(challengeId).populate(["agency_id",'sdg']);
    if (!findChallenge) throw new HttpException(409, 'Challenge Not Found');

    return findChallenge;
  }

  public async getChallengeStageById(challengeId: string): Promise<any> {
    const challengeData: Challenge = await this.challenges.findById(challengeId);


    var currentdate  = Date.now();
    var currentstage = '';
    var lefttime: any;
    var isstarted: boolean= false;
    var position: number;
    let steps = challengeData.steps;

      
    if((new Date(currentdate).getTime() < new Date(steps[0].end_date).getTime())){
      challengeData.currentstage = 'Challenge Opens In'
      lefttime =  new Date(steps[0].end_date).getTime() - new Date(currentdate).getTime()
      challengeData.lefttime = (lefttime/1000)
    }
    else{
      isstarted = true;
      for(let i = 0; i< steps.length;i++ ){
        console.log('i', i)
        if( (new Date(currentdate).getTime() > new Date(steps[i].end_date).getTime()) && (new Date(currentdate).getTime() < new Date(steps[i+1].end_date).getTime())){
          if(steps[i+1].stage_name === 'Idea Submission Closed'){
            currentstage = steps[i].stage_name
            console.log('inside if')
            console.log('stage name ic')
            position= i;
          }
          else{
          currentstage = steps[i+1].stage_name
          console.log('stage name else', currentstage)
          position= i+1;
          }
          lefttime =  new Date(steps[i+1].end_date).getTime() - new Date(currentdate).getTime()
          challengeData.currentstage = currentstage
          challengeData.lefttime = (lefttime/1000)
          console.log('lettime', lefttime)
          // element.set('currentstage',currentstage)
          console.log('match found', currentstage)
          
        }
      }
    }
      // console.log('hey hey',element.steps)

    var challenge_stage= {
      currentstage: currentstage,
      lefttime: lefttime,
      position: position,
      steps: steps
    }

    console.log(challenge_stage, 'j91082')
    if (!challengeData) throw new HttpException(409, 'Challenge Not Found');

    return challenge_stage;
  }

  public async findChallengeByAgency(agencyId: string): Promise<any> {
    const findChallenge = await this.challenges.find({agency_id:agencyId}).populate(["agency_id",'sdg']);
    if (!findChallenge) throw new HttpException(409, 'Challenge Not Found');

    return findChallenge;
  }

  

  public async createChallenge(challengeData: CreateChallengeDto): Promise<Challenge> {
    if (isEmpty(challengeData)) throw new HttpException(400, 'Challenge Data Not Found');

    //  const findChallenge: Challenge = await this.challenges.findOne({ category: challengeData.category,year:challengeData.year });
    //  if (findChallenge) throw new HttpException(409, `Category:${challengeData.category}, Year:${challengeData.year} already exists`);
    const createChallengeData: Challenge = await this.challenges.create(challengeData);
    return createChallengeData;
  }

  public async updateChallenge(challengeId: string, challengeData: Challenge): Promise<Challenge> {
    if (isEmpty(challengeData)) throw new HttpException(400, 'Challenge Data Not Found');
    const updateChallengeById: Challenge = await this.challenges.findByIdAndUpdate(challengeId, {$set:challengeData});
    if (!updateChallengeById) throw new HttpException(409, 'Challenge Data Not Found');

    return updateChallengeById;
  }

  public async deleteChallengeData(challengeId: string): Promise<Challenge> {
    const deleteChallengeById: Challenge = await this.challenges.findByIdAndDelete(challengeId);
    if (!deleteChallengeById) throw new HttpException(409, 'Challenge Data Not Found');

    return deleteChallengeById;
  }
}

export default ChallengeService;
