import { CreateAgencyDto } from '../dtos/agency.dto';
import HttpException from '../exceptions/HttpException';
import { Agency } from '../interfaces/agency.interface';
import agencyModel from '../models/agency.model';
import { isEmpty } from '../utils/util';
import { sendMail } from '../utils/mail';
import sdgModel from '../models/sdg.model';
import uniqueidModal from '../models/uniqueid.model';
import { User } from '../interfaces/user.interface';
import { createUniqueId } from '../utils/unique_id_generator';
import { Readable } from 'stream';
import { sdg } from '../utils/data';

class initialiseDataService {
  public agencies = agencyModel;
  public sdgModel = sdgModel;

  public async initialiseData() {
    //Check if existing
    let existingSdg = await sdgModel.find({});
    if (existingSdg.length == 0) {
      // Create readable stream from the array list of cards
      const readableStream = Readable.from(sdg);
      // Turn on the stream and repeat the process to create cards
      readableStream.on('data', async data => {
        await sdgModel.create(data);
      });
      console.log("Init Data");
      
    } else {
      console.log('SDG Already Exists');
    }
  }
}
export default initialiseDataService;
