import uniqueidModel from '../models/uniqueid.model';

const createUniqueId = async (type: any, agency_code: any) => {
  try {
    let code = agency_code.toLowerCase();
    let create = await uniqueidModel.create({
      type: type,
      agency_code: code,
      description: `Unique ID for ${type}`,
    });
    if (create) {
      return 'UID created';
    }
  } catch (error) {
    return 'UID Creation failed';
  }
};

const generate_unique_id = async (type: any, agency: any) => {
  let firstChar = type.toString().charAt(0);
  let data = await uniqueidModel.findOne({ type: type, agency_code: agency });
  if (data) {
    let id = '' + (Number(data.currentValue) + 1);
    var pad = '000';
    id = pad.substring(0, pad.length - id.length) + id;
    let uniqueid = `${firstChar}${new Date().getFullYear()}-${data.agency_code}-${id}`;
    return uniqueid;
  }
};

const uniqueIdIncrement = async (type: any, agency: any) => {
  let update = await uniqueidModel.updateOne({ type: type, agency_code: agency }, { $inc: { currentValue: 1 } });
  console.log(update);
};

export { generate_unique_id, uniqueIdIncrement, createUniqueId };
